import org.chocosolver.solver.variables.IntVar;


public class Alphabet {
		
		private char[] characters;
		private int[] index;
	
		public Alphabet(String chars) {
				characters = chars.toCharArray();
				index = new int[256];
				for(int i=0; i<256; ++i) {
						index[i] = -1;
				}
				for(int i=0; i<characters.length; ++i) {
						index[characters[i]] = i;
				}
		}
	
		public int size() {
				return characters.length;
		}
		
		public char get_char(int i) {
				return characters[i];
		}
		
		public int get_digit(char c) {
				return index[c];
		}
		
		public boolean known(char c) {
				return index[c] >= 0;
		}
		
		// public void print(int[] text) {
		// 		for(int i=0; i<text.length; ++i) {
		// 				System.out.print(get_char(text[i]));
		// 		}
		// 		// System.out.println();
		// }
		
		public void print(IntVar[] text) {
				if(text == null || text[0] == null)
						System.out.print("TODO");
				else
						for(int i=0; i<text.length; ++i) {
								System.out.print(get_char(text[i].getValue()));
						}
		}

    public static void main(String[] args) {
			Alphabet A = new Alphabet("ABFSJHREWT");
			
			for(int i=0; i<A.size(); ++i)
					System.out.println(A.get_char(i)+": "+A.get_digit(A.get_char(i)));
    }
}
