import java.util.*;


public class Rotor {
		
		private int N;
		private int[] forward;
		private int[] backward;
		private int position;
		private int init_position;
	
		public Rotor(int[] perm, int key) {
				N = perm.length;
				forward = new int[N];
				backward = new int[N];
				System.arraycopy( perm, 0, forward, 0, forward.length );
				for( int i = 0; i < N ; ++i ) backward[perm[i]] = i;
				set_key(key);
		}
	
		public void set_key(int key) {
				position = key;
				init_position = key;
		}
		
		public int get_position() {
				return position;
		}
		
		public boolean step() {
				position = (position + 1) % N;
				return position == init_position;
		}
		
    public int encrypt_forward(int c) {
        return forward[(position + c) % N];
		}
			
    public int  encrypt_backward(int c) {
        return (backward[c] + N - position) % N;
		}
		
		public int[] get_backward() {
				int[] b = new int[backward.length];
				System.arraycopy( backward, 0, b, 0, b.length );
				return b;
		}
		
		public int[] get_forward() {
				int[] f = new int[forward.length];
				System.arraycopy( forward, 0, f, 0, f.length );
				return f;
		}
		
    public static void main(String[] args) {
			int N = 10;
			int k = 3;
			
			List<Integer> p = new ArrayList<>();
			for (int i = 0; i < N; i++) {
			    p.add(i);
			}
			Collections.shuffle(p);
			int[] perm = new int[N];
			for(int i=0; i<N; ++i) {
				perm[i] = p.get(i);
			}
			
			Rotor r = new Rotor(perm, k);
			
			for(int c=0; c<10; ++c) {
				int f = r.encrypt_forward(c);
				assert c == r.encrypt_backward(f) ;
				System.out.println(c+" -> "+f);
				r.step();
				
				f = r.encrypt_forward(c);
				assert c == r.encrypt_backward(f) ;
				System.out.println(c+" -> "+f);
				r.step();
				
			}
			
    }
}
