import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.Solution;


public class Warmup {
	
	
		static public void transposeEncodeChar(Alphabet alphabet, int[] permutation) {
				
				Model model = new Model();
								
				IntVar plaintext = null;
				IntVar ciphertext = null;
				
				
				
				
				Solver solver = model.getSolver();
				Solution solution = solver.findSolution();
				while(solution != null) {
						alphabet.print(new IntVar[]{plaintext});
						System.out.print(" -> ");
						alphabet.print(new IntVar[]{ciphertext});
						System.out.println();

						solution = solver.findSolution();						
				}
		
		}
		
		static public void transposeEncodeText(Alphabet alphabet, String plaintext, int[] permutation) {
						
				Model model = new Model();
				char[] chars = plaintext.toCharArray();

				int N = alphabet.size();
				int K = chars.length;
				
				// IntVar[] plaintext = model.intVarArray("plain", length, 0, N-1);
				IntVar[] ciphertext = model.intVarArray("cipher", K, 0, N-1);
				
				for(int i=0; i<K; ++i) {
						IntVar plaintextchar = model.intVar(alphabet.get_digit(chars[i]));
						model.element( ciphertext[i], permutation, plaintextchar ).post();
				}
				
				
				Solver solver = model.getSolver();
				Solution solution = solver.findSolution();
				for(int k=0; solution != null && k<100; ++k) {
					System.out.print(plaintext + " -> ");
					alphabet.print(ciphertext);
					System.out.println();
					
					solution = solver.findSolution();
				}
		
		}
		
		static public void transposeDecodeText(Alphabet alphabet, String ciphertext, int[] permutation) {
						
				Model model = new Model();
								
				char[] chars = ciphertext.toCharArray();

				int N = alphabet.size();
				int K = chars.length;
				
				// IntVar[] plaintext = model.intVarArray("plain", length, 0, N-1);
				IntVar[] plaintext = model.intVarArray("plain", K, 0, N-1);
				
				for(int i=0; i<K; ++i) {
						IntVar ciphertextchar = model.intVar(alphabet.get_digit(chars[i]));
						model.element( ciphertextchar, permutation, plaintext[i] ).post();
				}
				
				
				Solver solver = model.getSolver();
				Solution solution = solver.findSolution();
				for(int k=0; solution != null && k<100; ++k) {
					alphabet.print(plaintext);
					System.out.print(" -> " + ciphertext);
					System.out.println();
					
					solution = solver.findSolution();
				}
		
		}

    public static void main(String[] args) {
				Alphabet A = new Alphabet("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
			
				int[] permutation = new int[]{15, 14, 5, 22, 24, 13, 25, 12, 18, 9, 1, 23, 20, 16, 17, 21, 7, 2, 3, 11, 4, 8, 6, 19, 0, 10};
			
			
				System.out.println("\nEXERCICE 1\n");
			
	  		Warmup.transposeEncodeChar(A, permutation);
				
				System.out.println("\n\nEXERCICE 2\n");
				    
	    	Warmup.transposeEncodeText(A, "IAMAREALSPYNOW", permutation);
				
				System.out.println();
				
				System.out.println("\n\nEXERCICE 3\n");
				    
	    	Warmup.transposeDecodeText(A, "MYXXRPQWGYXFRUYLRLMYOECYPE", permutation);
				
				System.out.println();
				
    }
}
